---
title: "JFokus 2020"
categories: life java
---

## Keynote: Connecting Developers and Digital Media

<iframe width="560" height="315" src="https://www.youtube.com/embed/iAcyMzw9ORI?t=897" frameborder="0" allow="encrypted-media" allowfullscreen></iframe>

Well... I guess the main point of the talk was to encourage developers to be more involved in
open source projects?.. But from my point of view that was an advertisment of weather dot com.

Unnecessarily long.

## Keynote: Graphs from Malmö to Panama and Beyond

<iframe width="560" height="315" src="https://www.youtube.com/embed/iAcyMzw9ORI?t=3429" frameborder="0" allow="encrypted-media" allowfullscreen></iframe>

That one was much closer to the IT world and interesting over all. By the way - can't say that Panama Papers discussed
that much in Russia - wonder why :)

## Getting the best out of Spring Cloud, Kubernetes, and Istio

[Presentation](https://www.jfokus.se/jfokus20-preso/Getting-the-best-out-of-Spring-Cloud--Kubernetes-and-Istio.pdf)

 * I like dumb containers and smart service mesh. So I would choose Istio over Spring Cloud.
 * It's always better when container is not aware about in what environment it's running.

## Deconstructing Deep Learning

[Presentation](https://www.jfokus.se/jfokus20-preso/Deconstructing-Deep-Learning.pdf)

That was really nice introduction into deep learning and some concepts about it.

## Machine Learning using Kubeflow and Kubernetes

Introduction to [Kubeflow](https://www.kubeflow.org/) with some practical examples.

Intriguing... I believe we should try it :)

## Quickie: K8S security - a shift left approach

Very short session and very loud speaker(literally). And not that much information.

I wish speaker didn't spend precious time on trying to show things live - some best-practices instead
would work much better.

### Takeaways
 * Read-only filesystem
 * Don't run as root

## Presentation: Continuous Visibility, No More Dashboards!

[Presentation](https://docs.google.com/presentation/d/1FCsDKs-hFkRwVM0cU7xeHx9q8NLoUgUrofPoI_OLr0M/edit?usp=sharing)

### Takeaways

 * Nice dashboards with fancy charts do not mean visibility
 * Centralized logging
 * Zero Barrier metrics(meaning zero barrier for a developer to add a metric)
 * Monitoring infrastructure
 * Prepare for a failure - train your recovery procedures, so any member of a team can do that.

## Presentation: Reinforcement Learning in 45 minutes

>Introduction to reinforcement learning where we implement a Pac-Man agent. The Pac-Man agent will learn how to solve different maps using Q-learning and Deep Q-learning.

That was fun. A lot of life demos. And Pac-Man.

## Presentation: Memory Efficient Java

Super good presentation about how easy is to kill your performance with to high rate of memory allocation.

### Takeaways

 * Memory allocation is costly
 * Side effects might affect whole application performance not just one bit
 * Attaching profiler can change application behaviour, so it works differently(JVM disables some optimizations)

## Presentation: The Hacker’s Guide to JWT Security

[Presentation](https://www.jfokus.se/jfokus20-preso/The-Hackers-Guide-to-JWT-Security.pdf)

### Takeaways

 * Don't use weak algorithms
 * Do not allow `none` algorithm
 * Make sure you verify private keys
 * Up until 2018 some libraries accepted public key in the request
 * Set up CORS properly. It's super important!
 * There are pros and cons to keep JWT in cookies and in session store. One approach is to have `Fingerprint claim: Hash(RANDOM)` in JWT and `Fingerprint claim: Hash(RANDOM)` in a cookie.
   Server side verification: `Hash(cookie) == Fingerprint claim in JWT`.
 * Use https!
 * Set expiration time
 * Read [JSON Web Token Cheat Sheet for Java](https://cheatsheetseries.owasp.org/cheatsheets/JSON_Web_Token_Cheat_Sheet_for_Java.html)

## Presentation: Protecting yourself against attacks through the build

[Presentation](https://www.jfokus.se/jfokus20-preso/Protecting-your-organization-against-attacks-via-the-build-system.pdf)

### Takeaways

 * Nothing is secure
 * Your tools can be compromised
 * Your CI can be compromised
 * Your dependencies can be compromised
 * Repositories you use can be compromised

All above have been exploited in the wild already.

## Presentation: Organisation Refactoring and Culture Hacking - Lessons from Software

[Presentation](https://www.jfokus.se/jfokus20-preso/Org-Structure-Refactoring-and-Culture-Hacking.pdf)

### Takeaways

[Weeks Of Coding Can Save Hours Of Planning](https://channels.theinnovationenterprise.com/articles/weeks-of-coding-can-save-hours-of-planning)

> features have no value until they are in the hands of a user and being used for a productive effort. So any activity not spent getting the next most valuable feature into the hands of a user quickly is just waste.

 * Organisation structure is best served by being in a constant state of (incremental) change.
 * The best people to drive these changes are those closest to the action - us, the makers.
 * Our existing maker skills are ideally suited for this work. 

#### The Advice Process

> Anyone can make any decision,
>
>after seeking advice from everyone who will be meaningfully affected,
>
>and those with expertise.

## Presentation: Get old, go slow, write code!

[Presentation](https://www.jfokus.se/jfokus20-preso/Get-old.pdf)

Super good presentation. Many things caused a lof of the feedback in the audience. 

### Takeaways

 * Average age of a programmer is 28 years.
 * This is younger than ANY other profession: doctors(51), teachers(42), product managers(42), bartenders(34), dishwashers(34).
 * Better be slow but produce quality then be quick and produce garbage.

## Quickie: Sumo crushes the test pyramid

Presenter started with things which I'm agree a lot, like:
 
 * Test pyramid is wrong
 * Behaviour or domain tests are better then unit tests
 * Unit tests are too much focused on implementation then on requirements
 * Too much mocking
 
But then he started to promote "Test language" like cucumber or spoke.
And with this I disagree: tests are written by programmers and should be easily refactored when needed.
Separating tests to "test specification" and "test implementation" makes them unmaintainable. 

## Keynote: Lessons Learned from the 737 Max

Quite emotional talk from [Ken Sipe](http://kensipe.blogspot.com/) about how and why that happened.

 * Cheap is expensive
 * [The cost of cheap](https://hdfmagazine.com/cost-going-cheap-expensive/)
